// http://www.javacodegeeks.com/2013/05/parsing-xml-using-dom-sax-and-stax-parser-in-java.html#dom
package dom;

import org.w3c.dom.*;
import javax.xml.parsers.*;
import fachklassen.Mitarbeiter;
import java.io.File;
import java.util.*;

public class MitarbeiterDomParser {

    public static void main(String[] args) throws Exception {
        //Get the DOM Builder Factory
        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        //Get the DOM Builder
        DocumentBuilder builder = factory.newDocumentBuilder();

        // Load and Parse the XML document
        // document contains the complete XML as a Tree.
        // sucht im Ordner build/classes nach der XML-Datei
//        Document document = builder.parse(ClassLoader.getSystemResourceAsStream("xml/employees.xml"));
        Document document = builder.parse(new File("employees.xml"));
        List<Mitarbeiter> empList = new ArrayList<>();

        // Iterating through the nodes and extracting the data.
        // Alle Mitarbeiter in der Mitarbeiterverwaltung ermitteln
        // Alle direkten Child-Elemente vom Root-Element ermitteln
        Node rootNode = document.getDocumentElement();
        NodeList nodeList = rootNode.getChildNodes();

        for (int i = 0; i < nodeList.getLength(); i++) {
            //We have encountered an <employee> tag.
            Node node = nodeList.item(i);
            if (node instanceof Element) {
//                if(node.getNodeName().equals("employee")){
//                    System.out.println("Mitarbeite");
//                }
                Mitarbeiter emp = new Mitarbeiter();
                // Mitarbeiter ID aus dem Attribut "id" ermitteln
                emp.setId(Integer.parseInt(node.getAttributes().getNamedItem("id").getNodeValue()));
                // Alle Attribute für die Mitarbeiter auswerten
                NodeList childNodes = node.getChildNodes();
                for (int j = 0; j < childNodes.getLength(); j++) {
                    Node childNode = childNodes.item(j);
                    //Identifying the child tag of employee encountered.
                    if (childNode instanceof Element) {
                        String content = childNode.getLastChild().getTextContent().trim();
                        switch (childNode.getNodeName()) {
                            case "age":
                                emp.setAlter(Integer.parseInt(content));
                                break;
                            case "name":
                                emp.setName(content);
                                break;
                            case "gender":
                                emp.setGeschlecht(content);
                                break;
                            case "role":
                                emp.setFunktion(content);
                                break;
                        }
                    }
                }
                empList.add(emp);
            }
        }
        //Alle Mitarbeiter aus der Liste ausgeben
        for (Mitarbeiter emp : empList) {
            System.out.println(emp);
        }
    }
}
