package dom;

import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

public class PartyDomParser {

    public static void main(String[] argv) {
        try {
            // ---- Parse XML Datei ----
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            DocumentBuilder builder = factory.newDocumentBuilder();
            Document document = builder.parse(new File("party.xml"));
            // root-Element auslesen -> Datum der Party ermitteln
            Node rootNode = document.getDocumentElement();
            System.out.println(rootNode.getAttributes().getNamedItem("datum").getNodeValue());

            // Gästeliste auslesen
            NodeList nodeList = document.getElementsByTagName("gast");

            // Alle Gäste befragen
            for (int i = 0; i < nodeList.getLength(); i++) {
                Node nodeMain = nodeList.item(i);
                System.out.println("Gast: " + nodeMain.getAttributes().getNamedItem("name").getNodeValue());
                NodeList nodeListChilds = nodeMain.getChildNodes();
//                if (nodeListChilds == null || nodeListChilds.getLength() == 0) {
//                    continue;
//                }
                // was haben die Gäste getrunken und wie ist ihr Zustand
                for (int j = 0; j < nodeListChilds.getLength(); j++) {
                    Node childNode = nodeListChilds.item(j);
                    if (childNode instanceof Element) {
                        Element eElement = (Element) childNode;
                        if (eElement.getNodeName().equals("getraenk")) {
                            System.out.println("trinkt: " + eElement.getTextContent());
                        }
//                        if (eElement.getNodeName().equals("zustand")) {
//                            System.out.println("nüchtern: " + eElement.getAttribute("nuechtern"));
//                        }
                    }
                }
            }
            Node newMainNode = document.createElement("gast");
            ((Element) newMainNode).setAttribute("name", "Max Muster");

            Node newChildNode = document.createElement("getraenk");
            Text newTextNode = document.createTextNode("Wein");
            newChildNode.appendChild(newTextNode);
            newMainNode.appendChild(newChildNode);
            rootNode.appendChild(newMainNode);
            
            // ---- XSLT transformer zum Schreiben einer neuen XML-Datei ----
            Transformer transformer = TransformerFactory.newInstance().newTransformer();
            transformer.setOutputProperty(OutputKeys.METHOD, "xml");
            transformer.setOutputProperty(OutputKeys.INDENT, "yes");

            DOMSource source = new DOMSource(document);
            FileOutputStream os = new FileOutputStream(new File("party2.xml"));
            StreamResult result = new StreamResult(os);
            transformer.transform(source, result);

        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
