package mitarbeiterDao;

import fachklassen.Mitarbeiter;
import java.sql.*;
import java.util.ArrayList;

public class MySqlMitarbeiterDAO implements IMitarbeiterDAO {

    private Statement stmt = null;
    private Connection dbVerbindung;

    public MySqlMitarbeiterDAO() throws Exception {
        this("localhost");
    }

    public MySqlMitarbeiterDAO(String host) throws MitarbeiterException {
        try {
            Class.forName("com.mysql.jdbc.Driver");
            String url = "jdbc:mysql://" + host + ":3306/employees";
            dbVerbindung = DriverManager.getConnection(url, "root", "geheim");
            stmt = dbVerbindung.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.MySqlMitarbeiterDAO");
        }
    }

    @Override
    public boolean mitarbeiterExists(int id) {
        try {
            ResultSet rs = stmt.executeQuery("SELECT * FROM employee WHERE id = " + id + ";");
            return rs.next();
        } catch (SQLException e) {
            return false;
        }
    }

    @Override
    public Mitarbeiter getMitarbeiter(int id) throws MitarbeiterException {
        try {
            String statement = "SELECT * FROM employee WHERE id = " + id + ";";
            ResultSet rs = stmt.executeQuery(statement);
            if (rs.next()) {
                return new Mitarbeiter(rs.getInt("id"), rs.getString("name"), rs.getString("gender"), rs.getInt("age"), rs.getString("role"));
            } else {
                return null;
            }
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.getMitarbeiter" + e);
        }
    }

    @Override
    public Mitarbeiter[] getAllMitarbeiter() throws MitarbeiterException {
        ArrayList<Mitarbeiter> alleMitarbeiter = new ArrayList<>();
        Mitarbeiter[] temp = new Mitarbeiter[1];
        try {
            ResultSet rs = stmt.executeQuery("SELECT * FROM employee;");
            while (rs.next()) {
                alleMitarbeiter.add(new Mitarbeiter(rs.getInt("id"),
                        rs.getString("name"), rs.getString("gender"),
                        rs.getInt("age"), rs.getString("role")));
            }
            if (alleMitarbeiter.size() > 0) {
                return alleMitarbeiter.toArray(temp);
            } else {
                return null;
            }
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.getAllMitarbeiter" + e);
        }
    }

    @Override
    public void addMitarbeiter(Mitarbeiter mitarbeiter) throws MitarbeiterException {
        try {
            if (!mitarbeiterExists(mitarbeiter.getId())) {
                stmt.executeUpdate("INSERT INTO employee SET id = '" + mitarbeiter.getId() + "', age = '" + mitarbeiter.getAlter()
                        + "', name ='" + mitarbeiter.getName() + "', gender = '" + mitarbeiter.getGeschlecht() + "', role = '" + mitarbeiter.getFunktion() + "'");
            }
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.addMitarbeiter" + e);
        }
    }

    @Override
    public void changeMitarbeiter(Mitarbeiter mitarbeiter) throws MitarbeiterException {
        try {
            stmt.executeUpdate("UPDATE employee SET age = '" + mitarbeiter.getAlter() + "', name = '" + mitarbeiter.getName()
                    + "', gender ='" + mitarbeiter.getGeschlecht() + "', role = '" + mitarbeiter.getFunktion() + "' WHERE id = '" + mitarbeiter.getId() + "';");
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.changeMitarbeitzer" + e);
        }
    }

    @Override
    public void removeMitarbeiter(Mitarbeiter mitarbeiter) throws MitarbeiterException {
        try {
            stmt.executeUpdate("DELETE FROM employee WHERE id = '" + mitarbeiter.getId() + "';");
        } catch (Exception e) {
            throw new MitarbeiterException("MySqlMitarbeiterDAO.removeMitarbeiter" + e);
        }
    }

}
