// http://www.javacodegeeks.com/2013/05/parsing-xml-using-dom-sax-and-stax-parser-in-java.html#dom
package stax;

import fachklassen.Mitarbeiter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamConstants;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamReader;

public class MitarbeiterStaxParser {

    public static void main(String[] args) throws XMLStreamException, FileNotFoundException {
        List<Mitarbeiter> empList = null;
        Mitarbeiter currEmp = null;
        String elementName;
        String content = null;
        XMLInputFactory xmlInputFactory = XMLInputFactory.newInstance();
//        XMLStreamReader xmlStreamReader = xmlInputFactory.createXMLStreamReader(
//                ClassLoader.getSystemResourceAsStream("xml/employees.xml"));
        XMLStreamReader xmlStreamReader = xmlInputFactory.createXMLStreamReader(new FileInputStream("employees.xml"));

        while (xmlStreamReader.hasNext()) {
            int event = xmlStreamReader.next();
            switch (event) {
                case XMLStreamConstants.START_ELEMENT:
                    elementName = xmlStreamReader.getLocalName();
                    if (elementName.equals("employees")) {
                        empList = new ArrayList<>();
                    } else if (elementName.equals("employee")) {
                        currEmp = new Mitarbeiter();
                        currEmp.setId(Integer.parseInt(xmlStreamReader.getAttributeValue(0)));
                    }
                    break;

                case XMLStreamConstants.CHARACTERS:
                    content = xmlStreamReader.getText().trim();
                    break;

                case XMLStreamConstants.END_ELEMENT:
                    elementName = xmlStreamReader.getLocalName();
                    if (elementName.equals("employee")) {
                        // Füge den neuen Mitarbeiter zur Liste hinzu
                        empList.add(currEmp);
                        // Alle anderen Tags dienen zum Setzen der Attribute
                    } else if (elementName.equals("age")) {
                        currEmp.setAlter(Integer.parseInt(content));
                    } else if (elementName.equals("name")) {
                        currEmp.setName(content);
                    } else if (elementName.equals("gender")) {
                        currEmp.setGeschlecht(content);
                    } else if (elementName.equals("role")) {
                        currEmp.setFunktion(content);
                    }
                    break;
                case XMLStreamConstants.START_DOCUMENT:
                    // 
                    break;
                case XMLStreamConstants.END_DOCUMENT:
                    //Print the employee list populated from XML
                    for (Mitarbeiter emp : empList) {
                        System.out.println(emp);
                    }
                    break;
            }
        }
    }
}
